require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    if(defined(&_KERNEL)  && !defined(&_LOCORE)) {
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub LOCK () {"lock";}' unless defined(&LOCK);
	} else {
	    eval 'sub LOCK () {1;}' unless defined(&LOCK);
	}
	eval 'sub __membar {
	    my($_f) = @_;
    	    eval q( &do {  &__asm  &__volatile($_f ::: \\"memory\\"); }  &while (0));
	}' unless defined(&__membar);
	eval 'sub virtio_membar_producer () {
	    eval q( &__membar(\\"\\"));
	}' unless defined(&virtio_membar_producer);
	eval 'sub virtio_membar_consumer () {
	    eval q( &__membar(\\"\\"));
	}' unless defined(&virtio_membar_consumer);
	eval 'sub virtio_membar_sync () {
	    eval q( &__membar(\\"mfence\\"));
	}' unless defined(&virtio_membar_sync);
	eval 'sub atomic_cas_uint {
	    my($_p, $_e, $_n) = @_;
    	    eval q( &_atomic_cas_uint(($_p), ($_e), ($_n)));
	}' unless defined(&atomic_cas_uint);
	eval 'sub atomic_cas_ulong {
	    my($_p, $_e, $_n) = @_;
    	    eval q( &_atomic_cas_ulong(($_p), ($_e), ($_n)));
	}' unless defined(&atomic_cas_ulong);
	eval 'sub atomic_cas_ptr {
	    my($_p, $_e, $_n) = @_;
    	    eval q( &_atomic_cas_ptr(($_p), ($_e), ($_n)));
	}' unless defined(&atomic_cas_ptr);
	eval 'sub x86_atomic_testset_u64 {
	    my($ptr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&x86_atomic_testset_u64);
	eval 'sub x86_atomic_testset_u32 {
	    my($ptr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&x86_atomic_testset_u32);
	eval 'sub x86_atomic_setbits_u32 {
	    my($ptr,$bits) = @_;
    	    eval q({  &__asm  &volatile( &LOCK \\" orl %1,%0\\" : \\"=m\\" (*$ptr) : \\"ir\\" ($bits)); });
	}' unless defined(&x86_atomic_setbits_u32);
	eval 'sub x86_atomic_clearbits_u32 {
	    my($ptr,$bits) = @_;
    	    eval q({  &__asm  &volatile( &LOCK \\" andl %1,%0\\" : \\"=m\\" (*$ptr) : \\"ir\\" (~$bits)); });
	}' unless defined(&x86_atomic_clearbits_u32);
	eval 'sub x86_atomic_clearbits_u64 {
	    my($ptr,$bits) = @_;
    	    eval q({  &__asm  &volatile( &LOCK \\" andq %1,%0\\" : \\"=m\\" (*$ptr) : \\"ir\\" (~$bits)); });
	}' unless defined(&x86_atomic_clearbits_u64);
	eval 'sub x86_atomic_testset_ul () { &x86_atomic_testset_u64;}' unless defined(&x86_atomic_testset_ul);
	eval 'sub x86_atomic_setbits_ul () { &x86_atomic_setbits_u64;}' unless defined(&x86_atomic_setbits_ul);
	eval 'sub x86_atomic_clearbits_ul () { &x86_atomic_clearbits_u64;}' unless defined(&x86_atomic_clearbits_ul);
	eval 'sub atomic_setbits_int () { &x86_atomic_setbits_u32;}' unless defined(&atomic_setbits_int);
	eval 'sub atomic_clearbits_int () { &x86_atomic_clearbits_u32;}' unless defined(&atomic_clearbits_int);
	undef(&LOCK) if defined(&LOCK);
    }
}
1;
